// demo.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"


#include <cstdlib>
#include <iostream>

#include <cube/cube_api.h>
#include <cube/base/cube_types.h>
#include <cube/base/cubestring.hpp>
#include <cube/icubepersona.h>
#include <cube/icubefriends.h>
#include <cube/icubeachievement.h>
#include <cube/icubeapps.h>
#include <cube/icubeinapppurchase.h>
#include <cube/icubeutil.h>
#include <cube/icubewindow.h>


#include <algorithm>

#include <shellapi.h>
#ifndef _WIN64

#ifdef _DEBUG
#pragma comment(lib, "cube_api_d.lib")
#else
#pragma comment(lib, "cube_api.lib")
#endif // _DEBUG

#else

#ifdef _DEBUG
#pragma comment(lib, "cube_api64_d.lib")
#else
#pragma comment(lib, "cube_api64.lib")
#endif // _DEBUG


#endif // _WIN32


#include <thread>

struct SystemChangeNotifyHandler :public Cube::ICubeNotifyHandler {
    SystemChangeNotifyHandler() {
        Init();

        std::thread(
            []() {
                for (;;) {
                    int x = Cube::GetCubeFactory()->Utils()->GetTimeCountSinceAppLaunch();
                    int m = x / 60;
                    int s = x % 60;
                    printf("\r: %d%d", m, s);
                    Sleep(1000);

                }
            }
        ).detach();
    }
    ~SystemChangeNotifyHandler() {
        UnInit();
    }
    void Init() {
        Cube::RegisterNotify(Cube::kCubeSystemNotify, this);
    }
    void UnInit() {
        Cube::UnRegisterNotify(Cube::kCubeSystemNotify);
    }

    virtual void OnNotify(Cube::ICubeNotify* param) override {
        switch (param->notifyId) {
        case Cube::kCubeSystemNotify:
            // Show MessageBox
            std::cout << int(param->GetResult()) << "\t" << param->GetResultData().c_str() << std::endl;
            break;
        }
    }
};

int main() {
    // IsNeedRestartApp must be called before using any other api functions
    if (Cube::IsNeedRestartApp(1000450)) {
        return 0;
    }

    // initialize, if it fails, this app must be exit
    if (!Cube::CubeInitialize()) {
        return 0;
    }

    SystemChangeNotifyHandler sysHandler;

    printf("\n");
    system("pause");
    Cube::CubeShutdown();


    return 0;
}