#ifndef icubinapppurchase_h__
#define icubinapppurchase_h__



#ifdef _WIN32
#pragma once
#endif

#include "./base/cube_types.h"
#include "./base/cubestring.hpp"
namespace Cube {
#pragma pack(push, 1)


enum InAppPurchaseProductDiscountType {
    kInAppPurchaseProductDiscountTypeInvalid     = 0,
    kInAppPurchaseProductDiscountTypeNone        = 1,  // ûۿ
    kInAppPurchaseProductDiscountTypePermanent   = 2,  // ۿ
    kInAppPurchaseProductDiscountTypeTimed       = 3,  // ʱۿ
};

struct CubeDiscountInfo {
    int32_t off;                            // ۿʣ[0~100)֮:
                                            // 15 - 15%off - 8.5
                                            // 20 - 20%off - 8
    int32_t discountPrice;                  // ۿۺļ۸,offֵԶ

    InAppPurchaseProductDiscountType type;  // ۿ
    uint32_t startTime;                     // ʱۿۿʼʱ䣬ֻʱۿЧ
    uint32_t endTime;                       // ʱۿ۽ʱ䣬ֻʱۿЧ
};

struct CubeInAppPurchaseProductExtraInfo {
    CubeString exchangeRule;    // ߵĺϳɹ
    CubeString bundleRule;      // ߵĴ
};

struct CubeInAppPurchaseProductInfo {
    CubeProductId_t id;                             // ID
    CubeString apiName;
    bool isPurchasable;                             // ǷԹ
    CubeString name;                                // 
    CubeString description;                         // 
    CubeString category;                            // 
    CubeString icon;                                // ͼ(Сͼ)url
    CubeString thumbnail;                           // С(ͼ)url
    CubeInAppPurchaseProductExtraInfo extraInfo;    // ߸Ϣ
    int32_t originalPrice;                          // ԭ, isPurchasable=trueʱЧ
    CubeString currencyType;                        // , isPurchasable=trueʱЧ
    CubeDiscountInfo discount;                      // ۿϢ, isPurchasable=trueʱЧ
};





struct CubeProductItem {
    CubeString apiName;
    int32_t quantity;
};

class ICubeInAppPurchase {
public:
    // ȡȫɹƷϢ
    virtual CubeResult AsyncRequestAllPurchasableProducts(const char* userData) = 0;

    virtual bool GetProductInfo(const char* apiName,
                                CubeInAppPurchaseProductInfo* product) = 0;


    virtual CubeResult AsyncCreateOrder(const CubeProductItem* cartItems,
                                        int32_t itemSize,
                                        const char* userData) = 0;

    //
//     virtual CubeResult AsyncPurchaseProducts(const CubeProductItem* cartItems,
//                                              int32_t itemSize,
//                                              const char* userData) = 0;

    virtual CubeResult AsyncFinishOrder(const char* orderId,
                                        const char* userData) = 0;

	virtual CubeResult AsyncGetOrderInfo(const char* orderId, const char* userData) = 0;
};

#pragma pack(pop)

}
#endif // icubinapppurchase_h__
