#ifndef icube_matchmaking_h__
#define icube_matchmaking_h__

#ifdef _WIN32
#pragma once
#endif

#include "./base/cube_types.h"

namespace Cube {

// Ȩ
enum LobbyAuthorityType {
    PrivateLoobyType = 0,		// ⲻɼ,ͨ
    PublicLoobyType = 1,	    // ȫԱɼ,κ˾ɼ
    FriendsOnlyLoobyType = 2,	// ѿɼ
};

// ʱʹõıȽ
enum LobbyComparisonType {
    LobbyComparisonNotEqual             = 0,
    LobbyComparisonLessThan             = 1,
    LobbyComparisonEqualToOrLessThan    = 2,
    LobbyComparisonEqualTo              = 3,
    LobbyComparisonEqualToOrGreaterThan = 4,
    LobbyComparisonGraterThan           = 5,
};

// ľɸѡ
enum LobbyDistanceFilterType {
    LobbyDistanceFilterDefault,		// ظϽ
    LobbyDistanceFilterSameRegion,  // رȫ
    LobbyDistanceFilterNear,		// ر
    LobbyDistanceFilterFar,			// λøԶĴ,ڶӳٲеϷ
    LobbyDistanceFilterWorld,	    // ȫ,κɸѡ
};

//////////////////////////////////////////////////////////////////////////
// ˵:ڲϷ,ṩƥ书
//
//////////////////////////////////////////////////////////////////////////
class ICubeMatchmaking {
public:

    // ȡб
    // úΪ첽
    // ú,ɸѡ
    virtual CubeResult SearchLobby() = 0;

    // ַɸѡ
    virtual void AddSearchLobbyStringFilter(const char* fieldToSearch, const char* valueToMatch, LobbyComparisonType comparisonType) = 0;

    // ɸѡ
    virtual void AddSearchLobbyIntFilter(const char* fieldToSearch, int32_t valueToMatch, LobbyComparisonType comparisonType) = 0;

    // ηΧ()ɸѡ
    virtual void AddSearchLobbyIntRangeFilter(const char* fieldToSearch, int32_t minValueToMatch, int32_t maxValueToMatch) = 0;

    // þɸѡ,ipλ
    virtual void SetSearchLobbyDistanceFilter(LobbyDistanceFilterType distanceFilter) = 0;

    // , ֵСٶȳ, ĬΪ10, Ϊ1
    virtual void SetSearchLobbyResultCount(int32_t maxResults) = 0;

    // 
    virtual CubeResult CreateLobby(const char* name, LobbyAuthorityType lobbyAuthority, int32_t maxMembers) = 0;

    virtual CubeResult JoinLooby(CubeId_t lobbyId) = 0;

    virtual void LeaveLooby(CubeId_t lobbyId) = 0;

    // 
    virtual bool InviteUserToLooby(CubeId_t lobbyId, CubeId_t inviteeCubeId) = 0;

    virtual void KickUser(CubeId_t lobbyId, CubeId_t kickUserCubeId) = 0;

    // شԱ
    virtual int32_t GetLoobyMemberCount(CubeId_t lobbyId) = 0;

    virtual CubeId_t GetLoobyMemberByIndex(CubeId_t lobbyId, int32_t memberIndex) = 0;

    // ȡԶ, ͬ. ֶָβʱ, false
    virtual bool GetLoobyData(CubeId_t lobbyId, const char* field, char* valueBuffer, int32_t valueBufferSize) = 0;

    // ´ӷȡ
    virtual bool ReloadLoobyData(CubeId_t lobbyId) = 0;

    // ôԶ, úȫԱ㲥ֵ, ϷLobbyDataUpdate֪ͨ
    virtual bool SetLoobyData(CubeId_t lobbyId, const char* field, const char* value) = 0;

};

}

#endif // icube_matchmaking_h__
