// demo.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"


#include <cstdlib>
#include <iostream>

#include <cube/cube_api.h>
#include <cube/base/cube_types.h>
#include <cube/icubepersona.h>
#include <cube/icubefriends.h>
#include <cube/icubeachievement.h>
#include <cube/icubeapps.h>
#include <cube/icubeinapppurchase.h>
#include <cube/base/cubestring.hpp>
#include <cube/icubeutil.h>
#include <algorithm>

#include <shellapi.h>
#ifndef _WIN64

#ifdef _DEBUG
#pragma comment(lib, "cube_api_d.lib")
#else
#pragma comment(lib, "cube_api.lib")
#endif // _DEBUG

#else

#ifdef _DEBUG
#pragma comment(lib, "cube_api64_d.lib")
#else
#pragma comment(lib, "cube_api64.lib")
#endif // _DEBUG


#endif // _WIN32

#include <thread>

class InAppPurchaseNotifyHandler :public Cube::ICubeNotifyHandler {
public:
    InAppPurchaseNotifyHandler() {
        Init();
    }
    ~InAppPurchaseNotifyHandler() {
        UnInit();
    }
    void Init() {
        Cube::RegisterNotify(Cube::kRequestAllPurchasableProductsResponse, this);
        Cube::RegisterNotify(Cube::kCreateOrderResponse, this);
        Cube::RegisterNotify(Cube::kPurchaseProductsResponse, this);
        Cube::RegisterNotify(Cube::kFinishOrderResponse, this);
    }
    void UnInit() {
        Cube::UnRegisterNotify(Cube::kRequestAllPurchasableProductsResponse);
        Cube::UnRegisterNotify(Cube::kPurchaseProductsResponse);
        Cube::UnRegisterNotify(Cube::kFinishOrderResponse);
    }

    virtual void OnNotify(Cube::ICubeNotify* param) override {
        switch (param->notifyId) {
        case Cube::kRequestAllPurchasableProductsResponse:
        {
            Cube::CubeProductItem items[] = {
                {"P1", 1},
            };
            auto inapp = Cube::GetCubeFactory()->InAppPurchase();
            inapp->AsyncCreateOrder(items, 1, "");
            Sleep(2000);
        }
        break;
        case Cube::kCreateOrderResponse:
        {
            ::ShellExecuteA(NULL, "open", param->resultData.c_str(), "", "", SW_SHOWNORMAL);
            std::cout << "PayUrl: " << param->resultData.c_str() << std::endl;
        }
        break;
        case Cube::kPurchaseProductsResponse:
        {
            auto inapp = Cube::GetCubeFactory()->InAppPurchase();
            inapp->AsyncFinishOrder(param->resultData.c_str(), "");

            int a = 0;
        }
        break;
        case Cube::kFinishOrderResponse:
        {
            Cube::CubeProductItem items[] = {
				{"P1", 1},
            };
            auto inapp = Cube::GetCubeFactory()->InAppPurchase();
			inapp->AsyncGetOrderInfo(param->resultData.c_str(), "");
        }
        break;

		case Cube::kGetOrderInfoResponse:
			std::cout << "OerderInfo: " << param->resultData.c_str() << std::endl;

			break;
        default:
            break;
        }
    }
};

int main(int argc, char* argv[]) {
    Cube::CubeString s1 = "";
    Cube::CubeString s2 = NULL;

    auto ss1 = s1.c_str();
    auto ss2 = s2.c_str();

    // IsNeedRestartApp must be called before using any other api functions
    if (Cube::IsNeedRestartApp(10000545)) {
        return 0;
    }

    // initialize, if it fails, this app must be exit
    if (!Cube::CubeInitialize()) {
        return 0;
    }

    std::cout << "Api Version" << Cube::GetApiVersion() << std::endl;

//     InAppPurchaseNotifyHandler inappHandler;
//     auto inapp = Cube::GetCubeFactory()->InAppPurchase();
//     inapp->AsyncRequestAllPurchasableProducts("");

    auto res = Cube::GetCubeFactory()->Apps()->CheckAppOwnership(NULL);
    // get Persona and Friends interface
    auto persona = Cube::GetCubeFactory()->Persona();
    auto f = Cube::GetCubeFactory()->Friends();

    // get my cubeId and nickname, stored in UTF-8 format
    std::cout << "cube id: " << persona->GetMyCubeId() << std::endl;
    std::cout << "token: " << persona->GetMyCubeToken() << std::endl;
    std::cout << "nickname: " << persona->GetPersonaNickname(persona->GetMyCubeId()) << std::endl;


    // friend iteration
    auto n = f->GetFriendCount();
    std::cout << "number of friends:" << n << std::endl;
    for (auto i = 0; i < n; i++) {
        auto cubeIid = f->GetFriendByIndex(i);
        std::cout << "number: " << cubeIid << ", nickname: " << persona->GetPersonaNickname(cubeIid) << std::endl;
    }
    auto s = persona->GetPersonaAvatarFile(persona->GetMyCubeId(), Cube::AvatarQuality::SmallAvatar);
    std::cout << std::endl;

    // set user achievement
    auto achievement = Cube::GetCubeFactory()->Achievement();
    achievement->AsyncSetAchievement("A1");
    // 	achievement->AsyncSetAchievement("ACH02");
    // 	achievement->AsyncSetAchievement("ACH03");


        //     achievement->AsyncSetAchievementProgress("test_achievement1", 7, 10);
    bool isUnlock; uint64_t unlockTime;
    int64_t currentValue;

    auto b = achievement->GetAchievement("ACH01", &isUnlock, &unlockTime, &currentValue);
    // 	for (;;) {
    // 		Sleep(100);
    // 	}
        // Finish
    printf("\n");
    system("pause");
    Cube::CubeShutdown();


    return 0;
}